local vector = require("vector3d")
local syncblock = false
function main()
    while not isSampAvailable() do wait(0) end
    sampRegisterChatCommand('tpp', function()
        if not syncblock then
            if arg ~= nil then
                local pos = {getCharCoordinates(1)}
                local res, x, y, z = SearchMarker(pos[1], pos[2], pos[3], 5555, true)
                if res then
                    lua_thread.create(coordMaster, x, y, z)
                end
            else
                local res, x, y, z = getTargetBlipCoordinatesFixed()
                if res then
                    lua_thread.create(coordMaster, x, y, z)
                end
            end
        else
            sampAddChatMessage('Teleport process = true', -1)    
        end
    end)
    wait(-1)
end

function onSendPacket(id)
    if syncblock and (id == 200 or id == 207) then
        return false
    end
end
speed = 0

function coordMaster(x,y,z) 
    local pos = {x,y,z}
    local char = {getCharCoordinates(PLAYER_PED)}
    local vecDist = getDistanceBetweenCoords3d(char[1], char[2], char[3], pos[1], pos[2], pos[3])
    local v = isCharInAnyCar(1) and storeCarCharIsInNoSave(1) or -1
    local coef = 4
    local start = os.time()
    local w = 50
    local step = 0
    local stepLimit = 15
    syncblock = true
    while getDistanceBetweenCoords3d(char[1], char[2], char[3], pos[1], pos[2], pos[3]) >= coef and syncblock do
        printStringNow(math.floor(100 - (getDistanceBetweenCoords3d(char[1], char[2], char[3], pos[1], pos[2], pos[3]) / vecDist) * 100).."% = "..speed.."ms - coef -  "..coef, 1555)
        local vector = vector(pos[1] - char[1], pos[2] - char[2], pos[3] - char[3])
        vector:normalize()
        char[1] = char[1] + vector.x * coef
        char[2] = char[2] + vector.y * coef
        char[3] = char[3] + vector.z * coef 
        if isCharInAnyCar(1) then
            coef = speed == 2 and 7 or 8
            SendVehicleSync(char[1], char[2], char[3])
            w = 50
            stepLimit = -1
        elseif isCharOnFoot(1) then
            coef = 4
            sendPlayerSync(char[1], char[2], char[3],0)
            w = 60
            stepLimit = -1
        end
        speed = speed < (isCharInAnyCar(1) and 2 or 0.7) and speed + 0.02 or speed 
        wait(w)
        
        step = step + 1
        if step == stepLimit then
            step = 0
            wait(300) 
        end
        if getDistanceBetweenCoords3d(char[1], char[2], char[3], pos[1], pos[2], pos[3]) <= coef then
            speed = 0
            syncblock = false
            setCharCoordinates(1,x,y,z)
        end
    end
end
function SearchMarker(posX, posY, posZ, radius, isRace)
    local ret_posX = 0.0
    local ret_posY = 0.0
    local ret_posZ = 0.0
    local isFind = false

    for id = 0, 31 do
        local MarkerStruct = 0
        if isRace then MarkerStruct = 0xC7F168 + id * 56
        else MarkerStruct = 0xC7DD88 + id * 160 end
        local MarkerPosX = representIntAsFloat(readMemory(MarkerStruct + 0, 4, false))
        local MarkerPosY = representIntAsFloat(readMemory(MarkerStruct + 4, 4, false))
        local MarkerPosZ = representIntAsFloat(readMemory(MarkerStruct + 8, 4, false))

        if MarkerPosX ~= 0.0 or MarkerPosY ~= 0.0 or MarkerPosZ ~= 0.0 then
            if getDistanceBetweenCoords3d(MarkerPosX, MarkerPosY, MarkerPosZ, posX, posY, posZ) < radius then
                ret_posX = MarkerPosX
                ret_posY = MarkerPosY
                ret_posZ = MarkerPosZ
                isFind = true
                radius = getDistanceBetweenCoords3d(MarkerPosX, MarkerPosY, MarkerPosZ, posX, posY, posZ)
            end
        end
    end

    return isFind, ret_posX, ret_posY, ret_posZ
end
function getTargetBlipCoordinatesFixed()
    local bool, x, y, z = getTargetBlipCoordinates(); if not bool then return false end
    requestCollision(x, y); loadScene(x, y, z)
    local bool, x, y, z = getTargetBlipCoordinates()
    return bool, x, y, z
end

function SendVehicleSync(x,y,z)
    local data = samp_create_sync_data("vehicle")
    data.vehicleId = select(2,sampGetVehicleIdByCarHandle(storeCarCharIsInNoSave(1)))
    data.position = {x,y,z}
    data.moveSpeed = {speed,speed,0.1}
    data.vehicleHealth = getCarHealth(storeCarCharIsInNoSave(1))
    data.send()
end

function sendPlayerSync(x, y, z)
	local data = samp_create_sync_data("player")
    data.position = {x,y,z}
    data.moveSpeed = {speed,0.1,0.1}
    data.send()
end

function samp_create_sync_data(sync_type, copy_from_player)
    local ffi = require 'ffi'
    local sampfuncs = require 'sampfuncs'
    local raknet = require 'samp.raknet'
    require 'samp.synchronization'

    copy_from_player = copy_from_player or true
    local sync_traits = {
        player = {'PlayerSyncData', raknet.PACKET.PLAYER_SYNC, sampStorePlayerOnfootData},
        vehicle = {'VehicleSyncData', raknet.PACKET.VEHICLE_SYNC, sampStorePlayerIncarData}
    }
    local data = ffi.new('struct ' .. sync_traits[sync_type][1], {})
    local func_send = function()
        local bs = raknetNewBitStream()
        raknetBitStreamWriteInt8(bs, sync_traits[sync_type][2])
        raknetBitStreamWriteBuffer(bs, tonumber(ffi.cast('uintptr_t', ffi.new('struct ' .. sync_traits[sync_type][1] .. '*', data))), ffi.sizeof(data))
        raknetSendBitStreamEx(bs, sampfuncs.HIGH_PRIORITY, sampfuncs.UNRELIABLE_SEQUENCED, 1)
        raknetDeleteBitStream(bs)
    end
    return setmetatable({send = func_send}, {__index = function(t, index) return data[index] end, __newindex = function(t, index, value) data[index] = value end})
end